10 '  REMPATCH  VERSION 4.0
20 '  LISTS AND SELECTIVELY REMOVES PATCHES APPLIED BY THE
30 '  LDOS "PATCH" UTILITY.  ONLY X TYPE PATCHES ARE VISIBLE.
35 '  REROUTE *LO TO SEND PATCH TEXT TO THE PRINTER OR DISK.
39 '
40 CLEAR 1000:DEFINT A-Z
50 DIM PL(20),PN$(20),PR(20),PD(1000):PZ=0:DZ=0
60 FOR I=0 TO 20:PN$(20)="":NEXT
70 DEF FNH1$(I%)=MID$("0123456789ABCDEF",(I%AND15)+1,1)
75 DEF FNH2$(I%)=FNH1$(I%/16)+FNH1$(I%)
80 CLS:PRINT:PRINT "REMPATCH":PRINT "LDOS PATCH LISTING AND REMOVAL UTILITY":PRINT
100 REM--OPEN FILE
110 LINE INPUT "FILESPEC: ";FS$
115 IF INSTR(FS$,"SYS6/SYS") THEN S6=-1:PRINT "CANNOT REMOVE PATCHES FROM SYS6" ELSE S6=0
120 OPEN "R",1,FS$,1:B1=0
130 FIELD 1,1 AS B$
140 PS=0
160 PRINT
170 PRINT "CONTAINS THE FOLLOWING PATCHES:"
180 OPEN "O",2,"*LO"   'FOR PATCH TEXT
200 REM--GET BLOCK TYPE
210 GOSUB 10000 
230 IF BY>31 THEN PRINT:PRINT "*** LOAD FILE FORMAT ERROR ***":PRINT:END
240 IF BY=7 THEN 1000
250 IF BY=2 THEN 2000
260 IF BY=1 THEN 3000
265 IF BY=4 THEN 5000
270 REM--SOME TYPE OF EMBEDDED TEXT
280 GOSUB 10000  'GET LENGTH
290 B1=B1+BY  'STEP PAST IT
295 GOTO 200
500 REM--PATCHES HAVE BEEN LOCATED.
520 IF PZ=0 THEN PRINT:PRINT "***  NONE  ***":PRINT:CLOSE:END
540 PRINT
600 REM--PROMPT FOR WHICH ONES TO BE REMOVED.
605 PR=0
607 IF S6 THEN 700
610 FOR I=1 TO PZ
620   PRINT "REMOVE ";PN$(I);
630   INPUT R$
640   PR(I)=( LEFT$(R$,1)="Y" OR LEFT$(R$,1)="y" )
645   IF PR(I) THEN PR=PR+1
650 NEXT I
660 PRINT
700 REM--REMOVE PATCHES
710 IF PR=0 THEN PRINT "NO PATCHES REMOVED":PRINT:CLOSE:END
720 FOR PP=1 TO PZ  'FOR EACH PATCH
730   IF PR(PP) THEN 800  'SKIP IF REMOVING
740   FOR IB=PL(PP) TO PL(PP+1)-1   'GET DATA FOR KEPT PATCH
750     GET 1,IB:DZ=DZ+1:PD(DZ)=ASC(B$)
760   NEXT IB
800 NEXT PP
810 REM--GET ENTRY POINT DATA
820 FOR IB=PL(PZ+1) TO PL(PZ+1)+3
830   GET 1,IB:DZ=DZ+1:PD(DZ)=ASC(B$)
840 NEXT IB
850 DZ=DZ+1
860 PD(DZ)=3
900 REM--WRITE REMAINING PATCHES AND ENTRY POINT BACK TO FILE
910 B1=PL(1)-1
920 FOR ID=1 TO DZ
930   LSET B$=CHR$(PD(ID))
940   B1=B1+1:PUT 1,B1
950 NEXT ID
952 REM--SNIP FILE
954 VP=VARPTR(B$)
956 DCB=PEEK(VP+1)+256*PEEK(VP+2)-32
958 POKE DCB+8,PEEK(DCB+5):POKE DCB+12,PEEK(DCB+10):POKE DCB+13,PEEK(DCB+11)
960 CLOSE
970 IF PR=1 THEN PRINT " 1 PATCH REMOVED" ELSE PRINT PR;"PATCHES REMOVED"
980 PRINT
999 END '*****************************************
1000 REM--PATCH FILE NAME
1001 PRINT#2,
1002 PS=-1
1005 PZ=PZ+1:PL(PZ)=B1  'SAVE LOCATION
1010 GOSUB 10000  'GET LENGTH
1020 L=BY
1030 FOR I=1 TO L
1040   GOSUB 10000
1050   PRINT#2,B$;
1055   PN$(PZ)=PN$(PZ)+B$
1060 NEXT
1070 PRINT#2,
1080 GOTO 200
2000 REM--ENTRY POINT (END OF FILE)
2010 PL(PZ+1)=B1
2020 GOTO 500
3000 REM--CODE SEGMENT
3010 GOSUB 10000  'GET LENGTH
3020 IF BY<3 THEN L=BY+256 ELSE L=BY
3030 IF PS THEN 4000
3040 B1=B1+L
3050 GOTO 200
4000 REM--PRINT OUT PATCHING INSTRUCTIONS
4010 GOSUB 10000:A0=BY:GOSUB 10000:A1=BY
4020 PRINT#2,"X'";FNH2$(A1);FNH2$(A0);"'=";
4030 FOR I=1 TO L-2
4040   GOSUB 10000:PRINT#2,FNH2$(BY);" ";
4050 NEXT
4060 PRINT#2,
4070 GOTO 200
5000 REM--END OF SECTION CODE
5010 PS=0
5020 GOTO 270
9999 END '****************************************
10000 REM--GET NEXT BYTE
10010 B1=B1+1
10020 GET 1,B1
10030 BY=ASC(B$)
10040 RETURN
